<template>
  <div class="conversation-details">
    <template v-if="chat && isLoadedChat">
      <slot
        name="header"
        :chat="chat"
      />
      <JKeyboardNavByFocus
        reverse
        class="conversation-details-container"
        @keydown.space.prevent
      >
        <JScrollbarContainer>
          <JScrollbarViewport
            :ref="(component) => viewportRef = component?.$el"
            class="conversation-details-content"
            @scroll="handleChatScroll"
          >
            <div
              ref="scrollContentRef"
              class="scroll-content"
            >
              <ConversationDetailsStart v-if="groupedMessages.length === 0" />
              <div
                v-for="(groupedMessage, index) in groupedMessages"
                :key="groupedMessage.time"
                class="group-messages"
              >
                <ConversationTimeDivider :time="groupedMessage.time" />
                <template
                  v-for="(message, messageIndex) in groupedMessage.messages"
                  :key="message.id"
                >
                  <div
                    :ref="(el) => {
                      observeForUnreadMessages(el, message, chat?.lastRead);
                      observeForLastMessage(
                        el,
                        message,
                        index === groupedMessages.length - 1 && messageIndex === groupedMessage.messages.length - 1,
                        );
                    }"
                    :class="{ 'conversation-details-message': message.type === MessageTypes.Default }"
                  >
                    <ConversationDetailsMessage
                      v-if="message.type === MessageTypes.Default"
                      :chat-id="chat.id"
                      :message="message"
                    />
                    <ChatCallMessage
                      v-else-if="message.type === MessageTypes.CallOffer"
                      :message="message"
                    />
                    <ChatEndCallMessage
                      v-else-if="message.type === MessageTypes.EndCall"
                      :message="message"
                    />
                    <CreatedChatGroupMessage
                      v-else-if="message.type === MessageTypes.CreateGroup"
                      :message="message"
                    />
                    <UserLeaveGroupMessage
                      v-else-if="message.type === MessageTypes.LeaveGroup"
                      :message="message"
                    />
                  </div>
                </template>
              </div>
            </div>
          </JScrollbarViewport>

          <JScrollbarTrack
            hide-track
            hide-thumb
          />
        </JScrollbarContainer>
      </JKeyboardNavByFocus>

      <div class="editor-container">
        <UserTypingMessage
          v-slot="{ userTypingMessage }"
          :chat="chat"
        >
          <Transition name="scale">
            <div
              v-if="userTypingMessage"
              class="typing-user"
            >
              <UserProfileMenu
                avatar-size="s"
                hide-status
                :user="userTypingMessage"
              >
                <UserProfile :user="userTypingMessage" />
              </UserProfileMenu>
              <JTypingDots class="typing-image" />
            </div>
          </Transition>
        </UserTypingMessage>
        <ConversationNewMessagesInfo
          :chat="chat"
          @click="moveScrollToBotoom(viewportRef)"
        />
        <SendMessage
          :chat="chat"
          @send="onSendMessage"
        />
      </div>
    </template>
  </div>
</template>

<script lang="ts" setup>
import {
  ref,
  watch,
  computed,
  nextTick,
  toRef,
} from 'vue';
import {
  JKeyboardNavByFocus,
  JTypingDots,
  JScrollbarContainer,
  JScrollbarTrack,
  JScrollbarViewport,
} from '@new-jira-clone/ui/src/components';
import useThrottle from '@new-jira-clone/ui/src/composables/utils/useThrottle';
import useDebounce from '@new-jira-clone/ui/src/composables/utils/useDebounce';
import useCustomScrollbar from '@new-jira-clone/ui/src/components/shared/JScrollbar/useCustomScrollbar';
import { useStickyScroll } from '@new-jira-clone/libs/src/composables/scroll/useStickyScroll';
import { SendMessage } from '@/features/send-message';
import { useObserverForUnreadMessages, useObserverForLastMessage } from '@/features/last-read';
import { useGroupMessages } from '@/features/group-messages';
import { UserProfile, UserProfileMenu } from '@/features/user-profile';
import { UserTypingMessage } from '@/features/typing-message';
import {
  ConversationTimeDivider,
  ConversationNewMessagesInfo,
  useConversationStateService,
  useConversationDetailsService,
} from '@/entities/Conversation';
import {
  ChatCallMessage,
  ChatEndCallMessage,
  CreatedChatGroupMessage,
  UserLeaveGroupMessage,
} from '@/entities/Message';
import { MessageTypes, useChatStore } from '@/shared';
import ConversationDetailsMessage from './ConversationDetailsMessage.vue';
import ConversationDetailsStart from './ConversationDetailsStart.vue';
import useFetchChatDetails from '../model/useFetchChatDetails';
import useChatDetailsPagination from '../model/useChatDetailsPagination';
import useHeightObserver from '../model/useHeightObserver';

const props = defineProps({
  chatId: {
    type: String,
    required: true,
  },
});

const { addNewChat } = useConversationStateService();
const { saveScrollPosition, getChatScrollPosition } = useConversationDetailsService();
const { getChatById: getSavedChatById } = useChatStore();
const { moveScrollTo, moveScrollToBotoom } = useStickyScroll();

const chat = computed(() => {
  const foundChat = getSavedChatById(props.chatId);

  if (foundChat) {
    return foundChat;
  }

  return null;
});

const {
  isLoadedChat,
  fetchChatDetailsIfNotSaved,
} = useFetchChatDetails();

const {
  messagesInCurrentPages,
  initDefaultPagination,
  getNewMessagesByScrollPosition,
} = useChatDetailsPagination(chat);

const { initScrollbar, onViewportScroll } = useCustomScrollbar(ref(10));

const viewportRef = ref<HTMLDivElement | null>(null);
const scrollContentRef = ref<HTMLDivElement | null>(null);

const { currentScrollContentHeight } = useHeightObserver(
  viewportRef,
  scrollContentRef,
  toRef(() => chat.value?.details.isScrollAtBottom ?? false),
);

const { groupedMessages } = useGroupMessages(messagesInCurrentPages);

const { observeForUnreadMessages } = useObserverForUnreadMessages(
  viewportRef,
  toRef(() => chat.value?.id ?? ''),
);

const { observeForLastMessage } = useObserverForLastMessage(
  viewportRef,
  toRef(() => chat.value?.id ?? ''),
);

const onSendMessage = async () => {
  await nextTick();
  moveScrollToBotoom(viewportRef.value);
};

const useFetchNewMessages = () => {
  let isLoadingNewMessages = false;

  return async (event: Event) => {
    if (chat.value === null || isLoadingNewMessages) return;
    isLoadingNewMessages = true;

    const newLoadedPage = await getNewMessagesByScrollPosition(event, currentScrollContentHeight.value);

    if (newLoadedPage === null || newLoadedPage === 1) {
      isLoadingNewMessages = false;
      return;
    }

    await nextTick();

    setTimeout(() => {
      isLoadingNewMessages = false;
    });
  };
};

const fetchNewMessagesOnScroll = useFetchNewMessages();

const debouncedSaveScrollPosition = () => {
  if (viewportRef.value?.scrollTop) {
    saveScrollPosition(props.chatId, Math.floor(viewportRef.value.scrollTop));
  }
};

const getNewMessagesByScrollPositionThrottled = useThrottle(fetchNewMessagesOnScroll, 200);
const saveScrollPositionDebounced = useDebounce(debouncedSaveScrollPosition, 500);

const handleChatScroll = (event: Event) => {
  getNewMessagesByScrollPositionThrottled(event);
  saveScrollPositionDebounced();
  onViewportScroll();
};

watch(
  () => props.chatId,
  async (newChatId, oldChatId) => {
    if (newChatId === oldChatId) return;

    const newChatDetails = await fetchChatDetailsIfNotSaved(newChatId);

    if (newChatDetails) {
      if (newChatDetails.messages === null) {
        throw new Error('Chat messages not found');
      } else {
        initDefaultPagination();
      }

      addNewChat(newChatDetails);
    }

    await nextTick();

    requestIdleCallback(() => {
      if (viewportRef.value && scrollContentRef.value) {
        initScrollbar(viewportRef.value, scrollContentRef.value);
      }
    });

    const savedScrollPosition = getChatScrollPosition(props.chatId);

    if (savedScrollPosition) {
      moveScrollTo(viewportRef.value, savedScrollPosition);
    } else {
      moveScrollToBotoom(viewportRef.value);
    }
  },
  { immediate: true },
);
</script>

<style scoped lang="scss">
$max-width-details: 970px;
$content-padding: 38px;

.conversation-details {
  display: flex;
  flex-direction: column;
  flex-shrink: 2;
  align-items: center;
  z-index: 3;
  position: relative;
  width: 100%;
  overflow: hidden;
  background-color: var(--j-app-bg);
}

.conversation-details-container {
  margin-bottom: 20px;
}

.conversation-details-content {
  margin: 0 auto;
  padding-right: $content-padding;
  padding-left: $content-padding;
  width: 100%;
  max-width: $max-width-details;
}

.scroll-content {
  height: auto;
  min-height: 100%;
}

.conversation-details-message {
  margin-bottom: 24px;
}

.group-messages {
 &:last-child {
  .conversation-details-message:last-child {
    margin-bottom: 0;
  }
 }

 & > :last-child {
  margin-bottom: 10px;
 }
}

.editor-container {
  flex-shrink: 0;
  position: relative;
  margin-bottom: 10px;
  padding: 0 $content-padding 0;
  max-width: $max-width-details;
  width: 100%;
  min-height: 80px;

  .w-editor {
    margin-right: 10px;
    margin: 30px 50px 30px 30px;
    background-color: white;
  }
}

.conversation-message:last-child {
  margin-bottom: 0;
}

.open-new-tab-icon {
  margin-left: auto;
  cursor: pointer;

  &:hover {
    color: rgb(var(--j-primary-color));
  }
}

.typing-user {
  display: flex;
  align-items: center;
  position: absolute;
  z-index: 1;
  top: -20px;
  margin-left: 16px;
  transition-delay: 0ms, 146ms;
  transition-duration: 146ms, 0ms;
  transition-timing-function: cubic-bezier(0.3, 0, 0.6, 1);
}

.scale-enter-from,
.scale-leave-to {
  top: 0px;
}

.typing-image {
  margin-left: 5px;
}
</style>
